 /*
 * file      : src/callbacks.c
 * project   : tm
 * with      : Gtk-2
 *
 * copyright : (C) 2012 by Claude BULIN
 *
 * TM - Edition des heures de travail / Edition of working hours
 * GNU General Public License
 * 
 * This file is part of TM.
 * 
 * TM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 * 
 * TM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with TM.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifdef HAVE_CONFIG_H
	#include "../config.h"
#endif

#ifdef ENABLE_NLS
	#include <libintl.h>
	#define _(String) gettext (String)
#endif

#include <gtk/gtk.h>

#ifdef ENABLE_STATIC_LIBRARY
	#include "../lib_tm/lib.h"
#endif

#include "global.h"
#include "callbacks.h"
#include "edit_year.h"
#include "configuser.h"
#include "win_info.h"
#include "fileselect.h"
#include "draw.h"
#include "win_new_year.h"
#include "win_adj_time.h"
#include "win_print.h"



VAR_CALLBACKS	VarCallbacks;


// 
// 
void on_spinbutton_matin_debut_h_realize( GtkWidget *widget, gpointer user_data )
{
	VarCallbacks.Adr_spinbutton_matin_debut_h = widget;
}
void on_spinbutton_matin_debut_mn_realize( GtkWidget *widget, gpointer user_data )
{
	VarCallbacks.Adr_spinbutton_matin_debut_mn = widget;
}
void on_spinbutton_matin_fin_h_realize( GtkWidget *widget, gpointer user_data )
{
	VarCallbacks.Adr_spinbutton_matin_fin_h = widget;
}
void on_spinbutton_matin_fin_mn_realize( GtkWidget *widget, gpointer user_data )
{
	VarCallbacks.Adr_spinbutton_matin_fin_mn = widget;
}
void on_spinbutton_soir_debut_h_realize( GtkWidget *widget, gpointer user_data )
{
	VarCallbacks.Adr_spinbutton_soir_debut_h = widget;
}
void on_spinbutton_soir_debut_mn_realize( GtkWidget *widget, gpointer user_data )
{
	VarCallbacks.Adr_spinbutton_soir_debut_mn = widget;
}
void on_spinbutton_soir_fin_h_realize( GtkWidget *widget, gpointer user_data )
{
	VarCallbacks.Adr_spinbutton_soir_fin_h = widget;
}
void on_spinbutton_soir_fin_mn_realize( GtkWidget *widget, gpointer user_data )
{
	VarCallbacks.Adr_spinbutton_soir_fin_mn = widget;
}
void on_entry_comment_realize( GtkWidget *widget, gpointer user_data )
{
	VarCallbacks.Adr_entry_comment = widget;
}
// 
// 
void on_spinbutton_time_value_changed( GtkSpinButton *spinbutton, gpointer user_data )
{
	EditYear_spinbutton_time_value_changed( spinbutton );
}
// 
// 
void on_entry_comment_changed( GtkEditable *editable, gpointer user_data )
{
	EditYear_entry_comment_changed();
}
// 
// 
void callbacks_button_new_year( gboolean BoolAccept )
{
	gchar	*Str = NULL;
	gint	RetDayOfYear;
	
	// g_print( "BoolAccept = %s\n", BoolAccept ? "TRUE" : "FALSE" );
	if( FALSE == BoolAccept ) {
		// gboolean libutils_test_write( gchar *path )
		// gboolean libutils_test_file_exist( Config.PathNameFileBase )
		// gboolean libutils_test_dir_exist (gchar *File)
		// if( TRUE == libutils_test_file_exist( Config.PathNameFileBase )
	}
	
	gtk_label_set_use_markup( GTK_LABEL(GLADE_GET_OBJECT("label_new_year")), TRUE );
	Str = g_strdup_printf( _("<b>Edition de l'annee [ %d ] pour le fichier [ %s ]</b>"), EditYear_get_new_year(), EditYear_get_namefile( Config.PathNameFileNEWBase ) );
	gtk_label_set_label( GTK_LABEL(GLADE_GET_OBJECT("label_new_year")), Str );
	g_free( Str );
	Str = NULL;
	
	EditYear_set_ready();
	EditYear_alloc_struct();
	RetDayOfYear = EditYear_select_new_year();
	EditYear_set_datas_to_spinbuttons( RetDayOfYear );
	EditYear_set_flag_buttons();
}
// 
// 
void on_button_new_year_clicked( GtkButton *button, gpointer user_data )
{
	EditYear_save_struct();
	WinNewYear_open( callbacks_button_new_year );
}
// 
// 
void callbacks_button_open_year( gchar *p_path )
{
	// OPEN FILENAME
	if( TRUE == EditYear_read_file( p_path )) {
		
		gchar	*Str = NULL;
		gint	RetDayOfYear;

		// STOCKAGE DU NOUVEAU PATH_NAME_FILE
		EditYear_set_pathnamefile( p_path );
		
		gtk_label_set_use_markup( GTK_LABEL(GLADE_GET_OBJECT("label_new_year")), TRUE );
		Str = g_strdup_printf( _("<b>Edition de l'annee [ %d ] pour le fichier [ %s ]</b>"), EditYear_get_new_year(), EditYear_get_namefile( Config.PathNameFileBase ) );
		gtk_label_set_label( GTK_LABEL(GLADE_GET_OBJECT("label_new_year")), Str );
		g_free( Str );
		Str = NULL;
		
		EditYear_set_ready();
		RetDayOfYear = EditYear_select_new_year();
		EditYear_set_datas_to_spinbuttons( RetDayOfYear );
		EditYear_set_flag_buttons();
	}
	else {
		EditYear_clear_year();
	}
}
// 
// 
void on_button_open_year_clicked( GtkButton *button, gpointer user_data )
{
	EditYear_save_struct();
	fileselect( _("Choix d'un fichier"), GTK_FILE_CHOOSER_ACTION_OPEN,  callbacks_button_open_year, Config.PathNameFileBase, WindMain );
}
// 
// 
void on_button_export_year_clicked( GtkButton *button, gpointer user_data )
{
	// EditYear_put_weeks();
	// WinExport_open( draw_call );
	WinPrint_open( draw_call );
}
// 
// 
void on_button_init_base_year_clicked( GtkButton *button, gpointer user_data )
{
	WinAdjTime_open();
}
// 
// 
void on_spinbutton_time_by_week_h_realize( GtkWidget *widget, gpointer user_data )
{
	gtk_spin_button_set_value( GTK_SPIN_BUTTON(widget), Config.TimeByWeek / 60 );
	VarCallbacks.Adr_spinbutton_time_by_week_h = widget;
}
void on_spinbutton_time_by_week_mn_realize( GtkWidget *widget, gpointer user_data )
{
	gtk_spin_button_set_value( GTK_SPIN_BUTTON(widget), Config.TimeByWeek % 60 );
	VarCallbacks.Adr_spinbutton_time_by_week_mn = widget;
}
void on_spinbutton_time_by_week_value_changed( GtkSpinButton *spinbutton, gpointer user_data )
{
	if( NULL != VarCallbacks.Adr_spinbutton_time_by_week_h && NULL != VarCallbacks.Adr_spinbutton_time_by_week_mn ) {
		
		Config.TimeByWeek  = (gint)gtk_spin_button_get_value( GTK_SPIN_BUTTON(VarCallbacks.Adr_spinbutton_time_by_week_h) );
		Config.TimeByWeek *= 60;
		Config.TimeByWeek += (gint)gtk_spin_button_get_value( GTK_SPIN_BUTTON(VarCallbacks.Adr_spinbutton_time_by_week_mn) );
		draw_year();
	}
}






















